--- func_math.c.1	2006-09-18 17:07:21.000000000 +0200
+++ func_math.c	2006-09-18 17:07:10.000000000 +0200
@@ -31,6 +31,7 @@
 #include <stdlib.h>
 #include <stdio.h>
 #include <string.h>
+#include <math.h>
 #include <sys/types.h>
 
 #include "asterisk/module.h"
@@ -47,6 +48,9 @@
 	MULTIPLYFUNCTION,
 	SUBTRACTFUNCTION,
 	MODULUSFUNCTION,
+	POWFUNCTION,
+	SHLEFTFUNCTION,
+	SHRIGHTFUNCTION,
 	GTFUNCTION,
 	LTFUNCTION,
 	GTEFUNCTION,
@@ -105,6 +109,16 @@
 	} else if ((op = strchr(mvalue1, '%'))) {
 		iaction = MODULUSFUNCTION;
 		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'P'))) {
+		iaction = POWFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'L'))) {
+		iaction = SHLEFTFUNCTION;
+		*op = '\0';
+	} else if ((op = strchr(mvalue1, 'R'))) {
+		iaction = SHRIGHTFUNCTION;
+		*op = '\0';
+	}	
 	} else if ((op = strchr(mvalue1, '>'))) {
 		iaction = GTFUNCTION;
 		*op = '\0';
@@ -195,6 +209,28 @@
 
 			break;
 		}
+	case POWFUNCTION :
+		ftmp = pow(fnum1,fnum2);
+		break;
+	case SHLEFTFUNCTION :
+	{
+		int inum1 = fnum1;
+		int inum2 = fnum2;
+
+	ftmp = (inum1 << inum2);
+
+	break;
+	}
+	case SHRIGHTFUNCTION :
+	{
+		int inum1 = fnum1;
+		int inum2 = fnum2;
+
+		ftmp = (inum1 >> inum2);
+
+		break;
+	}
+
 	case GTFUNCTION:
 		ast_copy_string(buf, (fnum1 > fnum2) ? "TRUE" : "FALSE", len);
 		break;
